/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Contents of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.114 - (hide annotations) (download)
Sun Jan 1 18:12:03 2012 UTC (2 years, 11 months ago) by pesa
Branch: MAIN
Changes since 1.113: +21 -18 lines
Minor coding style cleanup.

1 vapier 1.93 # Copyright 1999-2011 Gentoo Foundation
2 caleb 1.1 # Distributed under the terms of the GNU General Public License v2
3 pesa 1.114 # $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.113 2011/12/31 00:46:04 pesa Exp $
4 caleb 1.1
5     # @ECLASS: qt4-build.eclass
6     # @MAINTAINER:
7 pesa 1.98 # Qt herd <qt@gentoo.org>
8 ingmar 1.8 # @BLURB: Eclass for Qt4 split ebuilds.
9 caleb 1.1 # @DESCRIPTION:
10 pesa 1.98 # This eclass contains various functions that are used when building Qt4.
11 caleb 1.1
12 hwoarang 1.37 inherit base eutils multilib toolchain-funcs flag-o-matic versionator
13 caleb 1.1
14 abcd 1.59 MY_PV=${PV/_/-}
15 pesa 1.100 MY_P=qt-everywhere-opensource-src-${MY_PV}
16    
17 pesa 1.102 HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18 pesa 1.100 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19     LICENSE="|| ( LGPL-2.1 GPL-3 )"
20    
21     IUSE="aqua debug pch"
22    
23     [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24     [[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25     IUSE+=" +exceptions"
26 abcd 1.59
27 hwoarang 1.96 if version_is_at_least 4.7.99999999; then
28     IUSE+=" c++0x qpa"
29     fi
30    
31 pesa 1.101 DEPEND="dev-util/pkgconfig"
32 hwoarang 1.36 RDEPEND="
33     !<x11-libs/qt-assistant-${PV}
34     !>x11-libs/qt-assistant-${PV}-r9999
35     !<x11-libs/qt-core-${PV}
36     !>x11-libs/qt-core-${PV}-r9999
37     !<x11-libs/qt-dbus-${PV}
38     !>x11-libs/qt-dbus-${PV}-r9999
39 pesa 1.100 !<x11-libs/qt-declarative-${PV}
40     !>x11-libs/qt-declarative-${PV}-r9999
41 hwoarang 1.36 !<x11-libs/qt-demo-${PV}
42     !>x11-libs/qt-demo-${PV}-r9999
43     !<x11-libs/qt-gui-${PV}
44     !>x11-libs/qt-gui-${PV}-r9999
45 wired 1.65 !<x11-libs/qt-multimedia-${PV}
46     !>x11-libs/qt-multimedia-${PV}-r9999
47 hwoarang 1.36 !<x11-libs/qt-opengl-${PV}
48     !>x11-libs/qt-opengl-${PV}-r9999
49     !<x11-libs/qt-phonon-${PV}
50     !>x11-libs/qt-phonon-${PV}-r9999
51     !<x11-libs/qt-qt3support-${PV}
52     !>x11-libs/qt-qt3support-${PV}-r9999
53     !<x11-libs/qt-script-${PV}
54     !>x11-libs/qt-script-${PV}-r9999
55     !<x11-libs/qt-sql-${PV}
56     !>x11-libs/qt-sql-${PV}-r9999
57     !<x11-libs/qt-svg-${PV}
58     !>x11-libs/qt-svg-${PV}-r9999
59     !<x11-libs/qt-test-${PV}
60     !>x11-libs/qt-test-${PV}-r9999
61     !<x11-libs/qt-webkit-${PV}
62     !>x11-libs/qt-webkit-${PV}-r9999
63     !<x11-libs/qt-xmlpatterns-${PV}
64     !>x11-libs/qt-xmlpatterns-${PV}-r9999
65     "
66 abcd 1.55
67 abcd 1.59 S=${WORKDIR}/${MY_P}
68 yngwin 1.25
69 hwoarang 1.34 # @FUNCTION: qt4-build_pkg_setup
70     # @DESCRIPTION:
71 pesa 1.109 # Sets up PATH and LD_LIBRARY_PATH.
72 caleb 1.1 qt4-build_pkg_setup() {
73 abcd 1.57 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
74    
75 yngwin 1.66 # Protect users by not allowing downgrades between releases
76     # Downgrading revisions within the same release should be allowed
77 pesa 1.100 if has_version '>'${CATEGORY}/${P}-r9999; then
78     if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
79 yngwin 1.66 eerror "Sanity check to keep you from breaking your system:"
80     eerror " Downgrading Qt is completely unsupported and will break your system!"
81     die "aborting to save your system"
82     else
83     ewarn "Downgrading Qt is completely unsupported and will break your system!"
84     fi
85     fi
86 abcd 1.57
87 pesa 1.98 if [[ ${PN} == "qt-webkit" ]]; then
88 spatz 1.71 eshopts_push -s extglob
89 hwoarang 1.80 if is-flagq '-g?(gdb)?([1-9])'; then
90 spatz 1.71 echo
91     ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92     ewarn "You may experience really long compilation times and/or increased memory usage."
93     ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94     ewarn "For more info check out bug #307861"
95     echo
96     fi
97     eshopts_pop
98     fi
99    
100 abcd 1.55 PATH="${S}/bin${PATH:+:}${PATH}"
101 abcd 1.57 if [[ ${CHOST} != *-darwin* ]]; then
102     LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
103     else
104     DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
105 yngwin 1.63 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
106     # platform detection. Note: needs to come before any directories to
107     # avoid extract failure.
108     [[ ${CHOST} == *-apple-darwin* ]] && \
109 yngwin 1.66 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
110     ${QT4_EXTRACT_DIRECTORIES}"
111 abcd 1.57 fi
112 yngwin 1.20
113 abcd 1.55 # Make sure ebuilds use the required EAPI
114 abcd 1.57 if [[ ${EAPI} != [23] ]]; then
115     eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
116     eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
117     eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
118     die "qt4-build eclass requires EAPI=2 or EAPI=3"
119 yngwin 1.20 fi
120 caleb 1.1
121 abcd 1.55 if ! version_is_at_least 4.1 $(gcc-version); then
122 yngwin 1.20 ewarn "Using a GCC version lower than 4.1 is not supported!"
123     fi
124 caleb 1.1 }
125    
126 hwoarang 1.34 # @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
127     # @DESCRIPTION:
128 pesa 1.109 # Arguments for build_target_directories. Takes the directories in which the
129     # code should be compiled. This is a space-separated list.
130 hwoarang 1.34
131     # @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
132     # @DESCRIPTION:
133 pesa 1.109 # Space-separated list including the directories that will be extracted from
134     # Qt tarball.
135 hwoarang 1.34
136     # @FUNCTION: qt4-build_src_unpack
137     # @DESCRIPTION:
138 pesa 1.109 # Unpacks the sources.
139 yngwin 1.20 qt4-build_src_unpack() {
140 hwoarang 1.42 setqtenv
141 pesa 1.112
142     local tarball="${MY_P}.tar.gz" target= targets=
143 abcd 1.55 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
144 pesa 1.112 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
145     mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
146     do
147     targets+="${MY_P}/${target} "
148 ingmar 1.11 done
149    
150 pesa 1.112 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
151     tar -xzf "${DISTDIR}/${tarball}" ${targets}
152     eend $? || die "failed to unpack"
153 ingmar 1.11 }
154    
155 hwoarang 1.37 # @ECLASS-VARIABLE: PATCHES
156 pesa 1.110 # @DEFAULT_UNSET
157 hwoarang 1.37 # @DESCRIPTION:
158 pesa 1.110 # PATCHES array variable containing all various patches to be applied.
159     # This variable is expected to be defined in global scope of ebuild.
160     # Make sure to specify the full path. This variable is utilised in
161     # src_unpack/src_prepare phase, based on EAPI.
162 hwoarang 1.37 #
163 pesa 1.110 # @CODE
164     # PATCHES=( "${FILESDIR}/mypatch.patch"
165     # "${FILESDIR}/patches_folder/" )
166     # @CODE
167 hwoarang 1.34
168     # @FUNCTION: qt4-build_src_prepare
169     # @DESCRIPTION:
170     # Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
171 pesa 1.109 # the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
172 yngwin 1.20 qt4-build_src_prepare() {
173 hwoarang 1.42 setqtenv
174 yngwin 1.20 cd "${S}"
175 vapier 1.94
176 pesa 1.99 if version_is_at_least "4.7"; then
177     # fix libX11 dependency on non X packages
178 pesa 1.98 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
179     has ${PN} ${nolibx11_pkgs} && qt_nolibx11
180 pesa 1.99
181     qt_assistant_cleanup
182 hwoarang 1.77 fi
183 wired 1.69
184 abcd 1.57 if use aqua; then
185     # provide a proper macx-g++-64
186     use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
187    
188     sed -e '/^CONFIG/s:app_bundle::' \
189     -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
190 pesa 1.109 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
191 abcd 1.57 fi
192    
193 ingmar 1.7 if [[ ${PN} != qt-core ]]; then
194 pesa 1.100 skip_qmake_build
195     skip_project_generation
196 ingmar 1.7 symlink_binaries_to_buildtree
197     fi
198 hwoarang 1.24
199 abcd 1.57 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
200     # qmake bus errors with -O2 but -O3 works
201     replace-flags -O2 -O3
202     fi
203 jer 1.97
204 hwoarang 1.21 # Bug 178652
205 abcd 1.55 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
206 hwoarang 1.21 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
207     append-flags -fno-gcse
208 gengor 1.18 fi
209    
210 pesa 1.100 if use_if_iuse c++0x; then
211 hwoarang 1.96 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212     ewarn "this is an official standard, some of the reverse dependencies"
213     ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214     ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215     ewarn "disabled."
216     append-flags -std=c++0x
217     fi
218 pesa 1.98
219 gengor 1.30 # Unsupported old gcc versions - hardened needs this :(
220 abcd 1.55 if [[ $(gcc-major-version) -lt 4 ]] ; then
221 gengor 1.30 ewarn "Appending -fno-stack-protector to CXXFLAGS"
222     append-cxxflags -fno-stack-protector
223     # Bug 253127
224 gengor 1.29 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
225 pesa 1.109 -i mkspecs/common/g++.conf || die
226 gengor 1.29 fi
227    
228 ayoy 1.49 # Bug 261632
229     if use ppc64; then
230     ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
231     append-flags -mminimal-toc
232     fi
233    
234 pesa 1.109 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
235     sed -e "/^SYSTEM_VARIABLES=/i \
236     CC='$(tc-getCC)'\n\
237     CXX='$(tc-getCXX)'\n\
238     CFLAGS='${CFLAGS}'\n\
239     CXXFLAGS='${CXXFLAGS}'\n\
240     LDFLAGS='${LDFLAGS}'\n" \
241 pesa 1.114 -i configure \
242     || die "sed SYSTEM_VARIABLES failed"
243 pesa 1.98
244 pesa 1.113 # Respect CC, CXX, LINK and *FLAGS in config.tests
245     find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
246     sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
247     'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
248     'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
249     || die "sed config.tests failed"
250 wired 1.67
251 pesa 1.114 # Strip predefined CFLAGS from mkspecs (bug 312689)
252     sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
253    
254 hwoarang 1.24 # Bug 172219
255 pesa 1.113 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
256 ingmar 1.7
257 wired 1.67 if [[ ${CHOST} == *-darwin* ]]; then
258 abcd 1.57 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
259     # crippled (by design) :/
260 pesa 1.114 sed \
261     -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
262 abcd 1.57 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
263     -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
264     -e "s:-arch\s\w*::g" \
265 pesa 1.114 -i mkspecs/common/mac-g++.conf \
266     || die "sed mkspecs/common/mac-g++.conf failed"
267 abcd 1.57
268     # Fix configure's -arch settings that appear in qmake/Makefile and also
269     # fix arch handling (automagically duplicates our -arch arg and breaks
270     # pch). Additionally disable Xarch support.
271     sed \
272     -e "s:-arch i386::" \
273     -e "s:-arch ppc::" \
274     -e "s:-arch x86_64::" \
275     -e "s:-arch ppc64::" \
276     -e "s:-arch \$i::" \
277     -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
278     -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
279     -e "s:-Xarch_x86_64::g" \
280     -e "s:-Xarch_ppc64::g" \
281 pesa 1.114 -i configure mkspecs/common/mac-g++.conf \
282     || die "sed -arch/-Xarch failed"
283 abcd 1.57
284     # On Snow Leopard don't fall back to 10.5 deployment target.
285     if [[ ${CHOST} == *-apple-darwin10 ]] ; then
286     sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
287     -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
288 pesa 1.114 -i configure mkspecs/common/mac-g++.conf \
289     || die "sed deployment target failed"
290 abcd 1.57 fi
291     fi
292    
293     # this one is needed for all systems with a separate -liconv, apart from
294     # Darwin, for which the sources already cater for -liconv
295     if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
296 pesa 1.114 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
297 abcd 1.57 -i config.tests/unix/iconv/iconv.pro \
298 pesa 1.114 || die "sed iconv.pro failed"
299 abcd 1.57 fi
300    
301     # we need some patches for Solaris
302 pesa 1.114 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
303 abcd 1.57 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
304     # use GCC over SunStudio
305     sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
306 pesa 1.114 # do not flirt with non-Prefix stuff, we're quite possessive
307 abcd 1.57 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
308     mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
309 pesa 1.113
310 hwoarang 1.37 base_src_prepare
311 ingmar 1.7 }
312    
313 hwoarang 1.34 # @FUNCTION: qt4-build_src_configure
314     # @DESCRIPTION:
315     # Default configure phase
316 yngwin 1.20 qt4-build_src_configure() {
317 hwoarang 1.42 setqtenv
318 ingmar 1.7 myconf="$(standard_configure_options) ${myconf}"
319    
320 abcd 1.57 # this one is needed for all systems with a separate -liconv, apart from
321     # Darwin, for which the sources already cater for -liconv
322     use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
323     myconf+=" -liconv"
324    
325 pesa 1.98 if use_if_iuse glib; then
326 abcd 1.57 # use -I, -L and -l from configure
327     local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
328     # avoid the -pthread argument
329     myconf+=" ${glibflags//-pthread}"
330     unset glibflags
331     fi
332    
333 pesa 1.98 if use_if_iuse qpa; then
334 hwoarang 1.96 ewarn
335     ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
336     ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
337     ewarn "disable it before reporting any bugs related to this useflag."
338     ewarn
339     myconf+=" -qpa"
340     fi
341    
342 abcd 1.57 if use aqua ; then
343     # On (snow) leopard use the new (frameworked) cocoa code.
344 abcd 1.61 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
345 abcd 1.57 myconf+=" -cocoa -framework"
346    
347     # We are crazy and build cocoa + qt3support :-)
348     if use qt3support; then
349     sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
350 pesa 1.114 -i configure || die
351 abcd 1.57 fi
352    
353     # We need the source's headers, not the installed ones.
354     myconf+=" -I${S}/include"
355    
356     # Add hint for the framework location.
357     myconf+=" -F${QTLIBDIR}"
358     fi
359     else
360     # freetype2 include dir is non-standard, thus include it on configure
361     # use -I from configure
362     myconf+=" $(pkg-config --cflags freetype2)"
363     fi
364    
365 ingmar 1.7 echo ./configure ${myconf}
366     ./configure ${myconf} || die "./configure failed"
367 tommy 1.43 myconf=""
368 wired 1.90
369     prepare_directories ${QT4_TARGET_DIRECTORIES}
370 yngwin 1.20 }
371 ingmar 1.7
372 hwoarang 1.34 # @FUNCTION: qt4-build_src_compile
373 vapier 1.93 # @DESCRIPTION:
374     # Actual compile phase
375 yngwin 1.20 qt4-build_src_compile() {
376 hwoarang 1.42 setqtenv
377 yngwin 1.20
378 abcd 1.55 build_directories ${QT4_TARGET_DIRECTORIES}
379 caleb 1.1 }
380    
381 ayoy 1.76 # @FUNCTION: qt4-build_src_test
382     # @DESCRIPTION:
383     # Runs tests only in target directories.
384     qt4-build_src_test() {
385     for dir in ${QT4_TARGET_DIRECTORIES}; do
386     emake -j1 check -C ${dir}
387     done
388     }
389    
390 abcd 1.57 # @FUNCTION: fix_includes
391     # @DESCRIPTION:
392 pesa 1.109 # For MacOS X we need to add some symlinks when frameworks are
393 abcd 1.57 # being used, to avoid complications with some more or less stupid packages.
394     fix_includes() {
395 abcd 1.60 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
396 abcd 1.57 # Some packages tend to include <Qt/...>
397     dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
398    
399     # Fake normal headers when frameworks are installed... eases life later on
400 pesa 1.114 local dest f h
401 abcd 1.57 for frw in "${D}${QTLIBDIR}"/*.framework; do
402     [[ -e "${frw}"/Headers ]] || continue
403     f=$(basename ${frw})
404     dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
405     dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
406    
407     # Link normal headers as well.
408     for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
409     h=$(basename ${hdr})
410     dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
411     done
412     done
413     fi
414     }
415    
416 hwoarang 1.34 # @FUNCTION: qt4-build_src_install
417     # @DESCRIPTION:
418     # Perform the actual installation including some library fixes.
419 caleb 1.4 qt4-build_src_install() {
420 abcd 1.57 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
421 hwoarang 1.42 setqtenv
422 pesa 1.98
423 abcd 1.55 install_directories ${QT4_TARGET_DIRECTORIES}
424 ingmar 1.7 install_qconfigs
425 caleb 1.4 fix_library_files
426 abcd 1.57 fix_includes
427 pesa 1.98
428 hwoarang 1.78 # remove .la files since we are building only shared Qt libraries
429 pesa 1.114 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
430 caleb 1.4 }
431    
432 hwoarang 1.42 # @FUNCTION: setqtenv
433 pesa 1.110 # @INTERNAL
434 hwoarang 1.42 setqtenv() {
435     # Set up installation directories
436 abcd 1.57 QTPREFIXDIR=${EPREFIX}/usr
437     QTBINDIR=${EPREFIX}/usr/bin
438     QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
439     QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
440     QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
441     QTHEADERDIR=${EPREFIX}/usr/include/qt4
442 hwoarang 1.42 QTPLUGINDIR=${QTLIBDIR}/plugins
443 abcd 1.104 QTIMPORTDIR=${QTLIBDIR}/imports
444 pesa 1.109 QTDATADIR=${EPREFIX}/usr/share/qt4
445     QTTRANSDIR=${QTDATADIR}/translations
446 abcd 1.57 QTSYSCONFDIR=${EPREFIX}/etc/qt4
447 hwoarang 1.42 QTEXAMPLESDIR=${QTDATADIR}/examples
448     QTDEMOSDIR=${QTDATADIR}/demos
449 pesa 1.109 QMAKE_LIBDIR_QT=${QTLIBDIR}
450 abcd 1.57 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
451 pesa 1.109
452 hwoarang 1.42 PLATFORM=$(qt_mkspecs_dir)
453    
454     unset QMAKESPEC
455     }
456    
457 hwoarang 1.34 # @FUNCTION: standard_configure_options
458 pesa 1.110 # @INTERNAL
459 hwoarang 1.34 # @DESCRIPTION:
460     # Sets up some standard configure options, like libdir (if necessary), whether
461     # debug info is wanted or not.
462 caleb 1.1 standard_configure_options() {
463 pesa 1.107 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
464     -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
465     -importdir ${QTIMPORTDIR} -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR}
466     -sysconfdir ${QTSYSCONFDIR} -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
467     -opensource -confirm-license -shared -fast -largefile -stl -verbose
468     -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
469 caleb 1.1
470 grobian 1.58 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
471 caleb 1.1
472 pesa 1.107 # debug/release
473 ingmar 1.7 if use debug; then
474 abcd 1.55 myconf+=" -debug"
475 ingmar 1.7 else
476 abcd 1.55 myconf+=" -release"
477 ingmar 1.7 fi
478 abcd 1.55 myconf+=" -no-separate-debug-info"
479 caleb 1.1
480 pesa 1.107 # exceptions USE flag
481     local exceptions="-exceptions"
482     in_iuse exceptions && exceptions="$(qt_use exceptions)"
483     myconf+=" ${exceptions}"
484    
485     # disable RPATH on Qt >= 4.8 (bug 380415)
486     version_is_at_least 4.8 && myconf+=" -no-rpath"
487    
488     # precompiled headers don't work on hardened, where the flag is masked
489     myconf+=" $(qt_use pch)"
490    
491     # -reduce-relocations
492     # This flag seems to introduce major breakage to applications,
493     # mostly to be seen as a core dump with the message "QPixmap: Must
494     # construct a QApplication before a QPaintDevice" on Solaris.
495     # -- Daniel Vergien
496     [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
497    
498 abcd 1.57 use aqua && myconf+=" -no-framework"
499    
500 yngwin 1.20 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
501 flameeyes 1.27 # $(tc-arch). Therefore we convert it to supported values.
502     case "$(tc-arch)" in
503 pesa 1.103 amd64|x64-*) myconf+=" -arch x86_64" ;;
504     ppc-macos) myconf+=" -arch ppc" ;;
505     ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
506     sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
507     x86-macos) myconf+=" -arch x86" ;;
508     x86|x86-*) myconf+=" -arch i386" ;;
509     alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
510     hppa|sh) myconf+=" -arch generic" ;;
511 flameeyes 1.27 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
512 ingmar 1.11 esac
513    
514 caleb 1.1 echo "${myconf}"
515     }
516    
517 wired 1.90 # @FUNCTION: prepare_directories
518 hwoarang 1.34 # @USAGE: < directories >
519 pesa 1.110 # @INTERNAL
520 hwoarang 1.34 # @DESCRIPTION:
521 pesa 1.109 # Generates Makefiles for the given list of directories.
522 wired 1.90 prepare_directories() {
523 abcd 1.55 for x in "$@"; do
524 pesa 1.109 pushd "${S}"/${x} >/dev/null || die
525 pesa 1.98 einfo "Running qmake in: ${x}"
526 abcd 1.60 # avoid running over the maximum argument number, bug #299810
527     {
528     echo "${S}"/mkspecs/common/*.conf
529     find "${S}" -name '*.pr[io]'
530 abcd 1.104 } | xargs sed -i \
531     -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
532     -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
533     || die
534 ingmar 1.7 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
535 pesa 1.109 popd >/dev/null || die
536 wired 1.90 done
537     }
538    
539    
540     # @FUNCTION: build_directories
541     # @USAGE: < directories >
542 pesa 1.110 # @INTERNAL
543 wired 1.90 # @DESCRIPTION:
544 pesa 1.109 # Compiles the code in the given list of directories.
545 wired 1.90 build_directories() {
546     for x in "$@"; do
547 pesa 1.109 pushd "${S}"/${x} >/dev/null || die
548 wired 1.67 emake CC="$(tc-getCC)" \
549     CXX="$(tc-getCXX)" \
550     LINK="$(tc-getCXX)" || die "emake failed"
551 pesa 1.109 popd >/dev/null || die
552 caleb 1.1 done
553     }
554    
555 hwoarang 1.34 # @FUNCTION: install_directories
556     # @USAGE: < directories >
557 pesa 1.110 # @INTERNAL
558 hwoarang 1.34 # @DESCRIPTION:
559 pesa 1.109 # Runs emake install in the given directories, which are separated by spaces.
560 caleb 1.1 install_directories() {
561 abcd 1.55 for x in "$@"; do
562 pesa 1.109 pushd "${S}"/${x} >/dev/null || die
563 ingmar 1.7 emake INSTALL_ROOT="${D}" install || die "emake install failed"
564 pesa 1.109 popd >/dev/null || die
565 caleb 1.1 done
566     }
567    
568 ingmar 1.7 # @ECLASS-VARIABLE: QCONFIG_ADD
569     # @DESCRIPTION:
570     # List options that need to be added to QT_CONFIG in qconfig.pri
571 abcd 1.55 : ${QCONFIG_ADD:=}
572 ingmar 1.7
573     # @ECLASS-VARIABLE: QCONFIG_REMOVE
574     # @DESCRIPTION:
575     # List options that need to be removed from QT_CONFIG in qconfig.pri
576 abcd 1.55 : ${QCONFIG_REMOVE:=}
577 ingmar 1.7
578     # @ECLASS-VARIABLE: QCONFIG_DEFINE
579     # @DESCRIPTION:
580     # List variables that should be defined at the top of QtCore/qconfig.h
581 abcd 1.55 : ${QCONFIG_DEFINE:=}
582 ingmar 1.7
583 hwoarang 1.34 # @FUNCTION: install_qconfigs
584 pesa 1.110 # @INTERNAL
585 vapier 1.93 # @DESCRIPTION:
586 pesa 1.109 # Install gentoo-specific mkspecs configurations.
587 ingmar 1.7 install_qconfigs() {
588 zlin 1.9 local x
589     if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
590 ingmar 1.7 for x in QCONFIG_ADD QCONFIG_REMOVE; do
591     [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
592     done
593 abcd 1.57 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
594 ingmar 1.7 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
595 zlin 1.9 fi
596 ingmar 1.7
597 zlin 1.9 if [[ -n ${QCONFIG_DEFINE} ]]; then
598 ingmar 1.7 for x in ${QCONFIG_DEFINE}; do
599     echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
600     done
601 abcd 1.57 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
602 ingmar 1.7 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
603     fi
604     }
605    
606 hwoarang 1.34 # @FUNCTION: generate_qconfigs
607 pesa 1.110 # @INTERNAL
608 vapier 1.93 # @DESCRIPTION:
609 pesa 1.109 # Generates gentoo-specific qconfig.{h,pri}.
610 ingmar 1.7 generate_qconfigs() {
611     if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
612     local x qconfig_add qconfig_remove qconfig_new
613     for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
614     [[ -f ${x} ]] || continue
615 abcd 1.55 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
616     qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
617 ingmar 1.7 done
618    
619     # these error checks do not use die because dying in pkg_post{inst,rm}
620     # just makes things worse.
621     if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
622     # start with the qconfig.pri that qt-core installed
623     if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
624     "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
625     eerror "cp qconfig failed."
626     return 1
627     fi
628    
629     # generate list of QT_CONFIG entries from the existing list
630     # including qconfig_add and excluding qconfig_remove
631     for x in $(sed -n 's/^QT_CONFIG +=//p' \
632     "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
633 ssuominen 1.91 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
634 ingmar 1.7 done
635    
636     # replace the existing QT_CONFIG list with qconfig_new
637     if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
638     "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
639     eerror "Sed for QT_CONFIG failed"
640     return 1
641     fi
642    
643     # create Gentoo/qconfig.h
644     if [[ ! -e ${ROOT}${QTHEADERDIR}/Gentoo ]]; then
645     if ! mkdir -p "${ROOT}${QTHEADERDIR}"/Gentoo; then
646     eerror "mkdir ${QTHEADERDIR}/Gentoo failed"
647     return 1
648     fi
649     fi
650     : > "${ROOT}${QTHEADERDIR}"/Gentoo/gentoo-qconfig.h
651     for x in "${ROOT}${QTHEADERDIR}"/Gentoo/gentoo-*-qconfig.h; do
652     [[ -f ${x} ]] || continue
653     cat "${x}" >> "${ROOT}${QTHEADERDIR}"/Gentoo/gentoo-qconfig.h
654     done
655     else
656     rm -f "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri
657     rm -f "${ROOT}${QTHEADERDIR}"/Gentoo/gentoo-qconfig.h
658     rmdir "${ROOT}${QTDATADIR}"/mkspecs \
659     "${ROOT}${QTDATADIR}" \
660     "${ROOT}${QTHEADERDIR}"/Gentoo \
661     "${ROOT}${QTHEADERDIR}" 2>/dev/null
662     fi
663     fi
664     }
665    
666 hwoarang 1.34 # @FUNCTION: qt4-build_pkg_postrm
667 vapier 1.93 # @DESCRIPTION:
668 pesa 1.109 # Regenerate configuration when the package is completely removed.
669 ingmar 1.7 qt4-build_pkg_postrm() {
670     generate_qconfigs
671 caleb 1.1 }
672    
673 hwoarang 1.34 # @FUNCTION: qt4-build_pkg_postinst
674 vapier 1.93 # @DESCRIPTION:
675 pesa 1.109 # Regenerate configuration, plus throw a message about possible
676 hwoarang 1.34 # breakages and proposed solutions.
677 ingmar 1.7 qt4-build_pkg_postinst() {
678     generate_qconfigs
679 caleb 1.1 }
680    
681 pesa 1.100 # @FUNCTION: skip_qmake_build
682 pesa 1.110 # @INTERNAL
683 hwoarang 1.34 # @DESCRIPTION:
684 pesa 1.109 # Patches configure to skip qmake compilation, as it's already installed by qt-core.
685 pesa 1.100 skip_qmake_build() {
686 pesa 1.109 sed -i -e "s:if true:if false:g" "${S}"/configure || die
687 caleb 1.1 }
688    
689 pesa 1.100 # @FUNCTION: skip_project_generation
690 pesa 1.110 # @INTERNAL
691 hwoarang 1.34 # @DESCRIPTION:
692 pesa 1.109 # Exit the script early by throwing in an exit before all of the .pro files are scanned.
693 pesa 1.100 skip_project_generation() {
694 pesa 1.109 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
695 caleb 1.1 }
696    
697 hwoarang 1.34 # @FUNCTION: symlink_binaries_to_buildtree
698 pesa 1.110 # @INTERNAL
699 hwoarang 1.34 # @DESCRIPTION:
700 pesa 1.109 # Symlinks generated binaries to buildtree, so they can be used during compilation time.
701 ingmar 1.7 symlink_binaries_to_buildtree() {
702     for bin in qmake moc uic rcc; do
703 pesa 1.100 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
704 ingmar 1.7 done
705 caleb 1.1 }
706    
707 hwoarang 1.34 # @FUNCTION: fix_library_files
708 pesa 1.110 # @INTERNAL
709 hwoarang 1.34 # @DESCRIPTION:
710 pesa 1.109 # Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
711     # moves the *.pc files into the pkgconfig directory.
712 caleb 1.1 fix_library_files() {
713 pesa 1.109 local libfile
714 ingmar 1.7 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
715     if [[ -e ${libfile} ]]; then
716 pesa 1.98 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
717 ingmar 1.7 fi
718     done
719 caleb 1.1
720 pesa 1.109 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
721 ingmar 1.7 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
722     if [[ -e ${libfile} ]]; then
723 pesa 1.109 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
724 caleb 1.1
725 abcd 1.55 # Move .pc files into the pkgconfig directory
726 abcd 1.57 dodir ${QTPCDIR#${EPREFIX}}
727 pesa 1.109 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
728 ingmar 1.7 fi
729     done
730    
731     # Don't install an empty directory
732     rmdir "${D}"/${QTLIBDIR}/pkgconfig
733 caleb 1.1 }
734    
735 hwoarang 1.34 # @FUNCTION: qt_use
736     # @USAGE: < flag > [ feature ] [ enableval ]
737 yngwin 1.39 # @DESCRIPTION:
738 pesa 1.111 # This will echo "-${enableval}-${feature}" if <flag> is enabled, or
739     # "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
740 hwoarang 1.34 # will be used for that. If [enableval] is not specified, it omits the
741 pesa 1.111 # "-${enableval}" part.
742 caleb 1.1 qt_use() {
743 pesa 1.111 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
744 ingmar 1.7 }
745    
746 hwoarang 1.34 # @FUNCTION: qt_mkspecs_dir
747     # @RETURN: the specs-directory w/o path
748 yngwin 1.39 # @DESCRIPTION:
749 hwoarang 1.34 # Allows us to define which mkspecs dir we want to use.
750 caleb 1.1 qt_mkspecs_dir() {
751 pesa 1.109 local spec=
752 caleb 1.5 case ${CHOST} in
753     *-freebsd*|*-dragonfly*)
754 abcd 1.55 spec=freebsd ;;
755 caleb 1.5 *-openbsd*)
756 abcd 1.55 spec=openbsd ;;
757 caleb 1.5 *-netbsd*)
758 abcd 1.55 spec=netbsd ;;
759 ingmar 1.7 *-darwin*)
760 abcd 1.57 if use aqua; then
761     # mac with carbon/cocoa
762     spec=macx
763     else
764     # darwin/mac with x11
765     spec=darwin
766     fi
767     ;;
768     *-solaris*)
769     spec=solaris ;;
770 caleb 1.5 *-linux-*|*-linux)
771 abcd 1.55 spec=linux ;;
772 caleb 1.5 *)
773 pesa 1.100 die "Unknown CHOST, no platform chosen"
774 caleb 1.5 esac
775    
776     CXX=$(tc-getCXX)
777 abcd 1.55 if [[ ${CXX} == *g++* ]]; then
778     spec+=-g++
779     elif [[ ${CXX} == *icpc* ]]; then
780     spec+=-icc
781 caleb 1.5 else
782 pesa 1.100 die "Unknown compiler '${CXX}'"
783 caleb 1.5 fi
784 abcd 1.55 if [[ -n ${LIBDIR/lib} ]]; then
785     spec+=-${LIBDIR/lib}
786 hwoarang 1.42 fi
787 caleb 1.1
788 abcd 1.57 # Add -64 for 64bit profiles
789     if use x64-freebsd ||
790     use amd64-linux ||
791     use x64-macos ||
792     use x64-solaris ||
793     use sparc64-solaris
794     then
795     spec+=-64
796     fi
797    
798 caleb 1.5 echo "${spec}"
799 caleb 1.1 }
800    
801 hwoarang 1.77 # @FUNCTION: qt_assistant_cleanup
802 pesa 1.110 # @INTERNAL
803 hwoarang 1.77 # @DESCRIPTION:
804 pesa 1.99 # Tries to clean up tools.pro for qt-assistant ebuilds.
805     # Meant to be called in src_prepare().
806     # Since Qt 4.7.4 this function is a no-op.
807 hwoarang 1.77 qt_assistant_cleanup() {
808 pesa 1.99 # apply patching to qt-assistant ebuilds only
809     [[ ${PN} != "qt-assistant" ]] && return
810    
811     # no longer needed for 4.7.4 and later
812     version_is_at_least "4.7.4" && return
813    
814 hwoarang 1.77 # different versions (and branches...) may need different handling,
815     # add a case if you need special handling
816     case "${MY_PV_EXTRA}" in
817     *kde-qt*)
818     sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
819     -e "/mac/,/^embedded.*makeqpf$/d" \
820     -i tools/tools.pro || die "patching tools.pro failed"
821     ;;
822     *)
823     sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
824     -e "/mac/,/^embedded.*makeqpf$/d" \
825     -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
826     -i tools/tools.pro || die "patching tools.pro failed"
827     ;;
828     esac
829     }
830    
831     # @FUNCTION: qt_nolibx11
832 pesa 1.110 # @INTERNAL
833 hwoarang 1.77 # @DESCRIPTION:
834 pesa 1.109 # Ignore X11 tests for packages that don't need X libraries installed.
835 hwoarang 1.77 qt_nolibx11() {
836     sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
837     die "x11 check sed failed"
838     }
839    
840 ayoy 1.76 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

  ViewVC Help
Powered by ViewVC 1.1.20